# -*- coding: utf-8 -*-
# Generated by Django 1.9.13 on 2017-05-06 14:45
from __future__ import unicode_literals

from django.db import migrations, models
from attrim.models.type import Type
import django.db.models.deletion
import enumfields.fields
import parler.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('shuup', '0025_product_variation_ordering'),
    ]

    operations = [
        migrations.CreateModel(
            name='Attribute',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
            ],
        ),
        migrations.CreateModel(
            name='Class',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.SlugField(unique=True)),
                ('type', enumfields.fields.EnumIntegerField(enum=Type)),
                ('product_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attrim_classes', related_query_name='attrim_cls', to='shuup.ProductType')),
            ],
            options={
                'abstract': False,
            },
            bases=(parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='ClassTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('name', models.CharField(max_length=64, verbose_name='name')),
                ('master', models.ForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='attrim.Class')),
            ],
            options={
                'db_table': 'attrim_class_translation',
                'default_permissions': (),
                'managed': True,
                'db_tablespace': '',
                'verbose_name': 'class Translation',
            },
        ),
        migrations.CreateModel(
            name='Option',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('order', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('_value_decimal', models.DecimalField(blank=True, decimal_places=9, max_digits=36, null=True)),
                ('_value_str', models.TextField(blank=True)),
                ('attributes', models.ManyToManyField(blank=True, null=True, related_name='options', related_query_name='option', to='attrim.Attribute')),
                ('cls', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='options', related_query_name='option', to='attrim.Class')),
            ],
            options={
                'ordering': ['order'],
            },
            bases=(parler.models.TranslatableModelMixin, models.Model),
        ),
        migrations.CreateModel(
            name='OptionTranslation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('language_code', models.CharField(db_index=True, max_length=15, verbose_name='Language')),
                ('_value_trans_str', models.TextField(blank=True)),
                ('master', models.ForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='translations', to='attrim.Option')),
            ],
            options={
                'db_table': 'attrim_option_translation',
                'default_permissions': (),
                'managed': True,
                'db_tablespace': '',
                'verbose_name': 'option Translation',
            },
        ),
        migrations.AddField(
            model_name='attribute',
            name='cls',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attributes', related_query_name='attribute', to='attrim.Class'),
        ),
        migrations.AddField(
            model_name='attribute',
            name='product',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='attrim_attrs', related_query_name='attrim_attr', to='shuup.Product'),
        ),
        migrations.AlterUniqueTogether(
            name='optiontranslation',
            unique_together=set([('language_code', 'master')]),
        ),
        migrations.AlterUniqueTogether(
            name='classtranslation',
            unique_together=set([('language_code', 'master')]),
        ),
        migrations.AlterUniqueTogether(
            name='attribute',
            unique_together=set([('cls', 'product')]),
        ),
    ]
